program snake;{$MODE OBJFPC}
uses crt;
type pnt=record x,y:byte end;
var tail:array of pnt;
    head:pnt=(x:0;y:1);
    apple:pnt=(x:1;y:1);
    apw:byte=1;
    currend:word=0;
    dx:shortint=1;
    dy:shortint=0;
    i:word;
    dt:word=150;

function OnTail(xy:pnt):boolean;
var i:byte;
begin
OnTail:=true;
for i:=0 to high(tail) do
   if (tail[i].x=xy.x) and (tail[i].y=xy.y) then exit;
OnTail:=false
end;

procedure writeHead;
begin
    gotoxy(head.x,head.y);
    if dx>0 then write('<') else if dx<0 then write('>')
        else if dy<0 then write('v') else write('^');
end;

procedure accelerate(i:shortint);
begin
    if (dt-10*i>=50)and(dt-10*i<=1000) then dt-=10*i
end;

begin
cursoroff;
textcolor(black);
textbackground(lightgray);
clrscr;
setlength(tail,3);
randomize;
repeat
    if tail[currend].x<>0 then begin
        gotoxy(tail[currend].x,tail[currend].y);
        write(' ');
    end;
    gotoxy(head.x,head.y);
    if dx<>0 then write('-') else write('|');
    tail[currend]:=head;
    head.x:=head.x+dx;
    head.y:=head.y+dy;
    if OnTail(head) then break;
    if currend<>high(tail) then inc(currend) else currend:=0;
    writeHead;
    if keypressed then if readkey=#0 then case readkey of
        'H':if dy=0 then begin dx:=0;dy:=-1 end
            else accelerate(-dy);
        'K':if dx=0 then begin dx:=-1;dy:=0 end
            else accelerate(-dx);
        'P':if dy=0 then begin dx:=0;dy:=1 end
            else accelerate(dy);
        'M':if dx=0 then begin dx:=1;dy:=0 end
            else accelerate(dx);
    end else readkey;
    if (head.x=apple.x) and (head.y=apple.y) then begin
      setlength(tail,length(tail)+apw);
      if apw>0 then for i:=high(tail)-apw downto currend do begin
              tail[i+apw]:=tail[i];tail[i].x:=0
      end;
      if apw>=10 then begin
        gotoxy(head.x,head.y);
        write(' ');
        repeat head.x:=succ(random(79));head.y:=succ(random(24));
        until not OnTail(head);
        writeHead;
      end;
      apw:=random(12);
      repeat apple.x:=succ(random(79));apple.y:=succ(random(24));
      until not OnTail(apple);
      gotoxy(apple.x,apple.y);
      if apw<10 then write(apw) else write('T');
      gotoxy(1,1);
      write(high(tail));
    end;
    delay(dt);
until (head.x+dx=0) or (head.x+dx=81)//or
       or (head.y+dy=0) or (head.y+dy=26);
textcolor(lightgray);
textbackground(black);
gotoxy(head.x,head.y);
write('*');
gotoxy(30,13);
write('G A M E   O V E R');
cursoron;
readln;
end.
